﻿using System;
using System.Collections.Generic;

namespace ProtectionProxy
{
    class PictureManager
    {
        List<IView> pictures = new List<IView>();
        string login_user = string.Empty;
        public void Login(string user)
        {
            login_user = user;
            Console.WriteLine("{0} 님께서 로긴 하였습니다.",login_user);
        }
        public void MakePicture(string name)
        {
            if(login_user != string.Empty)
            {
                pictures.Add(new Picture(name,login_user));
            }
        }        
        public void MakePicture(string name,List<string> available_users)
        {
            if(login_user != string.Empty)
            {
                ProtectionPicture  pro_picture =
                                         MakeProtectionPicture(name,available_users);
                pictures.Add(pro_picture);
            }
        }
        public void ListPicture()
        {
            ProtectionPicture pp=null;
            foreach(IView ivew in pictures)
            {
                pp = ivew as ProtectionPicture;
                if(pp != null)
                {
                    pp.SetUser(login_user);
                }
                ivew.View();
            }
        }
        public void Logout()
        {
            Console.WriteLine("{0}님께서 로그 아웃 하였습니다.",login_user);
            login_user = string.Empty;
        }
        ProtectionPicture MakeProtectionPicture(string name,List<string> available_users)
        {
            ProtectionPicture  pro_picture = new ProtectionPicture(name,login_user);
            foreach(string uname in available_users)
            {
                pro_picture.AddAvailableUser(login_user,uname);
            }
            return pro_picture;
        }

    }
}
